#include <assert.h>

#include "stdprj.h"
#include "test10.h"

#define RUNFLAG (Memory[0])
#define VCHAR (Memory[1])

void Test10::Reset()
{
   // clear Memory
   Memory.Clear();

   // Test1 is halted after Reset()
   RUNFLAG = FALSE;
}

void Test10::Run()
{
   // Exit on error!
   assert(IsHalted());

   // set RUNFLAG
   RUNFLAG = TRUE;
}

int Test10::IsHalted()
{
   // test RUNFLAG
   return(!RUNFLAG);
}

void Test10::Step()
{
   // Exit on error!
   assert(IsRunning());

   // halt Test1 on the end of the program
   if (VCHAR == 0xFE)
   {
      // set RUNFLAG
      RUNFLAG = FALSE;
      // Exit on error!
      assert(IsHalted());
   }
   else
   {
      VCHAR += 2;
      // Exit on Error!
      assert(IsRunning());
   }
}
