#include <assert.h>
#include <limits.h>

#include "stdprj.h"
#include "test3.h"

#define RUNFLAG (Memory[0])
#define VCHAR1 (Memory[1])
#define VCHAR2 (Memory[2])

void Test3::Reset()
{
   // clear Memory
   Memory.Clear();

   // Test1 is halted after Reset()
   RUNFLAG = FALSE;
}

void Test3::Run()
{
   // Exit on error!
   assert(IsHalted());

   // set RUNFLAG
   RUNFLAG = TRUE;
}

int Test3::IsHalted()
{
   // test RUNFLAG
   return(!RUNFLAG);
}

void Test3::Step()
{
   // Exit on error!
   assert(IsRunning());

   // execute step
   VCHAR1++;

   // halt Test3 Maschine at the end of program
   // set RUNFLAG
   if (VCHAR1 == UCHAR_MAX)
   {
      RUNFLAG = FALSE;
      // Exit on error!
      assert(IsHalted());
   }
}
