#include <assert.h>
#include <limits.h>

#include "stdprj.h"
#include "test5.h"

#define RUNFLAG (Memory[0])
#define VCHAR1 (Memory[1])
#define VCHAR2 (Memory[2])

void Test5::Reset()
{
   // clear Memory
   Memory.Clear();

   // Test5 is halted after Reset()
   RUNFLAG = FALSE;
}

void Test5::Run()
{
   // Exit on error!
   assert(IsHalted());

   // set RUNFLAG
   RUNFLAG = TRUE;
}

int Test5::IsHalted()
{
   // test RUNFLAG
   return(!RUNFLAG);
}

void Test5::Step()
{
   // Exit on error!
   assert(IsRunning());

   // halt Test5 at the end of program
   // set RUNFLAG
   if ((VCHAR1 == UCHAR_MAX) && (VCHAR2 == UCHAR_MAX))
   {
      RUNFLAG = FALSE;
      // Exit on error!
      assert(IsHalted());
   }

   // execute step
   if (VCHAR1 == UCHAR_MAX)
   {
      VCHAR2++;
   }
   VCHAR1++;
}
