#include <assert.h>
#include <limits.h>

#include "stdprj.h"
#include "test8.h"

#define RUNFLAG (Memory[0])
#define VCHAR1 (Memory[1])
#define VCHAR2 (Memory[2])

void Test8::Reset()
{
   // clear Memory
   Memory.Clear();

   // Test8 is halted after Reset()
   RUNFLAG = FALSE;
}

void Test8::Run()
{
   // Exit on error!
   assert(IsHalted());

   // set RUNFLAG
   RUNFLAG = TRUE;
}

int Test8::IsHalted()
{
   return(!RUNFLAG);
}

void Test8::Step()
{
   // Exit on error!
   assert(IsRunning());

   // execute step
   if (VCHAR1 == UCHAR_MAX)
   {
      VCHAR2++;
   }
   VCHAR1++;

   // let Test8 run into an infinite loop
   // Exit on error!
   assert(IsRunning());
}
